/*---------------------------------------------------------------------------*
 *
 *                  wish - windowing user friendly shell
 *                 --------------------------------------
 *
 *              (c) Copyright Hellmuth Michaelis 1989 - 1993
 *
 *                  Eggerstedtstr. 28
 *                  22765 Hamburg 
 *                  Germany
 *
 *                  Tel:    +49 / 40 / 384298    (private)
 *                  Tel:    +49 / 40 / 55903-170 (at work)
 *                  e-mail: hm@hcshh.hcs.de
 *
 *           All rights are reserved except as explicitly granted
 *                  by written permission of the author.
 *
 *             See the file COPYING, distributed with wish, for
 *                  restriction and warranty information
 *
 *---------------------------------------------------------------------------*
 *
 *	Last Edit-Date: [Mon Aug 30 11:36:22 1993]
 *
 *	-hm	initial creation
 *	-hm	debug / streamline
 *	-hm	wildcards
 *
 *----------------------------------------------------------------------------*/

struct item {
	int row;		/* name row position */
	int col;		/* name column position */
	char *name;		/* field name */
	int nl;			/* name length */
	int type;		/* item type */
#define ITEM_ONOFF	0		/* YES / NO */
#define ITEM_STRING	1		/* a string */
#define ITEM_CHAR	2		/* a character */
#define ITEM_NOCHANGE	0x80		/* user cannot chage item at run-time */
	int *value;		/* pointer to variable [...hmmm] */
	char *help;		/* help/description string */
	struct item *next;	/* ptr to next item struct */
	struct item *prev;	/* ptr to previous item struct */	
};

struct item i_ret, i_attr, i_pres, i_fkey, i_link, i_point, i_pager, i_editor,
		i_delim, i_wild, i_wldon, i_cdrom, i_cdnop, i_dotfn;

#define FIRST_I		(&i_ret)

/* ----- changable ON/OFF ----- */

struct item i_ret = {
	2, 0, "   Return: ", 11, ITEM_ONOFF, (int *)&opt_return,
	"Specify wait for RETURN/ENTER key after executing an external command",
	&i_pres, &i_delim
};

struct item i_pres = {
	2, 26, " Preserve: ", 11, ITEM_ONOFF, (int *)&opt_preserve, 
	"Preserve current directory when moving up in directory tree",
	&i_link, &i_ret
};

struct item i_link = {
	2, 52, "    Links: ", 11, ITEM_ONOFF, (int *)&opt_links, 
	"Enable detection and display of links in the attribute window",
	&i_point, &i_pres
};

struct item i_point = {
	4, 0, "      Dot: ", 11, ITEM_ONOFF, (int *)&opt_point, 
	"Enable to display the current directory as a dot",
	&i_wldon, &i_link
};

struct item i_wldon = {
	4, 26, "WildEnabl: ", 11, ITEM_ONOFF, (int *)&opt_wildon, 	
	"Enable wildcard filename display filtering",
	&i_delim, &i_point
};

struct item i_delim = {
	4, 52, "Delimiter: ", 11, ITEM_CHAR, (int *)&opt_delimiter, 
	"Character to be used a a horizontal delimiter between windows",
	&i_cdrom, &i_wldon
};

struct item i_cdrom = {
	6, 0, "   CD-Rom: ", 11, ITEM_ONOFF, (int *)&opt_cdrom,
	"Do special filename processing for cdrom filenames containing ';'",
	&i_cdnop, &i_delim
};

struct item i_cdnop = {
	6, 26, "CDNoProgs: ", 11, ITEM_ONOFF, (int *)&opt_cdnoprog, 		
	"Take all executable programs on CDROM as data files for display",
	&i_dotfn, &i_cdrom
};

struct item i_dotfn = {
	6, 52, " DotNames: ", 11, ITEM_ONOFF, (int *)&opt_dotnames,	
	"Display Filenames starting with a Dot",
	&i_wild, &i_cdnop
};

/* ----- changable STRING ----- */

struct item i_wild = {
	8, 0, " Wildcard: ", 11, ITEM_STRING, (int *)&opt_wild[0], 
	"Wildcard string for files being displayed in the file window",
	&i_attr, &i_dotfn
};


/* ----- NOT changeable ON/OFF ----- */

struct item i_attr = {
	12, 0, "  Attribs: ", 11, ITEM_ONOFF | ITEM_NOCHANGE, (int *)&opt_attrib, 
	"Display the current file's attributes and Permissions (NOT CHANGEABLE)",
	&i_fkey, &i_wild
};

struct item i_fkey = {
	12, 40, "    Fkeys: ", 11, ITEM_ONOFF | ITEM_NOCHANGE, (int *)&opt_labels, 
	"Display virtual function key labels at bottom of the screen (NOT CHANGEABLE)",
	&i_pager, &i_attr
};

/*----------------------- string variables -------------------------------*/

struct item i_pager = {
	14, 0, "    Pager: ", 11, ITEM_STRING | ITEM_NOCHANGE, (int *)&opt_more[0], 
	"External command for program to display text (NOT CHANGEABLE)",
	&i_editor, &i_fkey	
};

struct item i_editor = {
	16, 0, "   Editor: ", 11, ITEM_STRING | ITEM_NOCHANGE, (int *)&opt_edit[0], 
	"External command for program to edit text (NOT CHANGEABLE)",
	&i_ret, &i_pager
};

/*---------------------------------- EOF ------------------------------------*/
