/*---------------------------------------------------------------------------*
 *
 *                  wish - windowing user friendly shell
 *                  ------------------------------------
 *
 *               Copyright (c) 1988-1993 Hellmuth Michaelis
 *
 *                  Eggerstedtstr. 28
 *                  22765 Hamburg
 *                  Germany
 *
 *                  Tel:    +49 / 40 / 384298    (private)
 *                  Tel:    +49 / 40 / 55903-170 (at work)
 *                  e-mail: hm@hcshh.hcs.de
 *
 *                          --------oOo--------
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *---------------------------------------------------------------------------*
 *
 *	Last Edit-Date: [Mon Aug 30 19:51:56 1993]
 *
 *	-hm	init file ".wishrc"
 *	-hm	wildcards
 *
 *----------------------------------------------------------------------------*/

#include "wish.h"		/* everything we want */
#include "control.h"		/* control-characters */
#include "rcinit.h"		/* .wishrc definitions */

static void onoff(char *string, int *var);
static void optchar(char *string, unsigned char *var);
static void optstr(char *string, char dest[]);

/*---------------------------------------------------------------------------*
 *	get user configuration from file "$HOME/.wishrc"
 *---------------------------------------------------------------------------*/
void readrc(void)
{
	char buffer[MAXPATHLEN+1];	/* gp buffer */
	FILE *fp;
	
	sprintf(buffer, "%s/%s", envhome, WISHRC);

	if((fp = fopen(buffer, "r")) == NULL)
		return;

	while((fgets(buffer, MAXPATHLEN, fp)) != NULL)
	{

/* comments */
		if(buffer[0] == '#' || buffer[0] == ' ' || buffer[0] == '\t')
		{
			continue;
		}
/* booleans */
		else if(!strncmp(buffer, RC_ATTR, strlen(RC_ATTR)))
		{
			onoff(buffer, &opt_attrib);
		}
		else if(!strncmp(buffer, RC_PRESERVE, strlen(RC_PRESERVE)))
		{
			onoff(buffer, &opt_preserve);
		}
		else if(!strncmp(buffer, RC_FKEYS, strlen(RC_FKEYS)))
		{
			onoff(buffer, &opt_labels);
		}
		else if(!strncmp(buffer, RC_LINKS, strlen(RC_LINKS)))
		{
			onoff(buffer, &opt_links);
		}
		else if(!strncmp(buffer, RC_POINT, strlen(RC_POINT)))
		{
			onoff(buffer, &opt_point);
		}
		else if(!strncmp(buffer, RC_RETURN, strlen(RC_RETURN)))
		{
			onoff(buffer, &opt_return);
		}
		else if(!strncmp(buffer, RC_WILDON, strlen(RC_WILDON)))
		{
			onoff(buffer, &opt_wildon);
		}
		else if(!strncmp(buffer, RC_CDROM, strlen(RC_CDROM)))
		{
			onoff(buffer, &opt_cdrom);
		}
		else if(!strncmp(buffer, RC_CDNOPROG, strlen(RC_CDNOPROG)))
		{
			onoff(buffer, &opt_cdnoprog);
		}
		else if(!strncmp(buffer, RC_DOTNAMES, strlen(RC_DOTNAMES)))
		{
			onoff(buffer, &opt_dotnames);
		}
/* strings */
		else if(!strncmp(buffer, RC_PAGER, strlen(RC_PAGER)))
		{
			optstr(buffer, opt_more);			
		}
		else if(!strncmp(buffer, RC_EDITOR, strlen(RC_EDITOR)))
		{
			optstr(buffer, opt_edit);
		}
		else if(!strncmp(buffer, RC_WILDCARD, strlen(RC_WILDCARD)))
		{
			optstr(buffer, opt_wild);
		}
/* characters */
		else if(!strncmp(buffer, RC_DELIMITER, strlen(RC_DELIMITER)))
		{
			optchar(buffer, &opt_delimiter);
		}
	}
}

/*---------------------------------------------------------------------------*
 *	process on/off strings
 *---------------------------------------------------------------------------*/
static void onoff(char *string, int *var)
{
	char *ptr;
	
	if((ptr = (char *)index(string, '=')) == NULL)
		return;
		
	ptr++;

	if(!strncmp(ptr, RC_ON, strlen(RC_ON)))
	{
		*var = 1;
	}
	else if(!strncmp(ptr, RC_OFF, strlen(RC_OFF)))
	{
		*var = 0;
	}
}

/*---------------------------------------------------------------------------*
 *	process chars
 *---------------------------------------------------------------------------*/
static void optchar(char *string, unsigned char *var)
{
	unsigned char *ptr;
	
	if((ptr = (unsigned char *)index(string, '=')) == NULL)
		return;
		
	ptr++;

	if(isprint(*ptr))
		*var = *ptr;		
}

/*---------------------------------------------------------------------------*
 *	process strings
 *---------------------------------------------------------------------------*/
static void optstr(char *string, char dest[])
{
	char *ptr, *bptr;
	
	if((ptr = (char *)index(string, '=')) == NULL)
		return;
		
	ptr++;

	bptr = dest;
	
	while(*ptr && (*ptr != '#') && (isprint(*ptr)) && (!isspace(*ptr)))
		*bptr++ = *ptr++;

	*bptr = '\0';
}

/*--------------------------------- EOF ------------------------------------*/
