/*---------------------------------------------------------------------------*
 *
 *                  wish - windowing user friendly shell
 *                  ------------------------------------
 *
 *               Copyright (c) 1988-1993 Hellmuth Michaelis
 *
 *                  Eggerstedtstr. 28
 *                  22765 Hamburg
 *                  Germany
 *
 *                  Tel:    +49 / 40 / 384298    (private)
 *                  Tel:    +49 / 40 / 55903-170 (at work)
 *                  e-mail: hm@hcshh.hcs.de
 *
 *                          --------oOo--------
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *---------------------------------------------------------------------------*
 *
 *	last edit-date: [Mon Aug 30 19:52:27 1993]
 *
 *---------------------------------------------------------------------------*/

#include "wish.h"

void timeout_hdlr(int sig);
static void make_time(void);

/*---------------------------------------------------------------------------*
 *	init time display in header
 *---------------------------------------------------------------------------*/
void init_time(void)
{
	signal(SIGALRM, &timeout_hdlr);
	make_time();
	alarm(30);
}

/*---------------------------------------------------------------------------*
 *	print current time into header
 *---------------------------------------------------------------------------*/
static void make_time(void)
{
	static struct tm *tmptr;
	static time_t t;
	static char buf[6];
	
	time(&t);
	tmptr = localtime(&t);
	sprintf(buf,"%02d:%02d", tmptr->tm_hour,tmptr->tm_min);

	strcpy(headerline+75,buf);
}

/*---------------------------------------------------------------------------*
 *	the timeout handler
 *---------------------------------------------------------------------------*/
void timeout_hdlr(int sig)
{
	static int i;

	signal(SIGALRM, SIG_IGN);

	make_time();
	
	if(!errorflag)
	{
		i = 0;
		if(COLS > 80)
			i = (COLS - 80)/2;
		wmove(cmnd_w, C_HEAD, 75+i );
		wattron(cmnd_w, A_REVERSE);
		waddstr(cmnd_w, headerline+75);
		wattroff(cmnd_w, A_REVERSE);
		wmove(cmnd_w, C_LINE, curcol());
		wrefresh(cmnd_w);
	}
	alarm(30);
	signal(SIGALRM, timeout_hdlr);
}	

/*---------------------------------------------------------------------------*
 *	stop updating the time
 *---------------------------------------------------------------------------*/
void suspend_time(void)
{
	signal(SIGALRM, SIG_IGN);
}

/*---------------------------------------------------------------------------*
 *	restart updating the time
 *---------------------------------------------------------------------------*/
void resume_time(void)	
{
	signal(SIGALRM, &timeout_hdlr);
	make_time();
}	

/*---------------------------------- EOF -------------------------------------*/
