/*---------------------------------------------------------------------------*
 *
 *                  wish - windowing user friendly shell
 *                  ------------------------------------
 *
 *               Copyright (c) 1988-1993 Hellmuth Michaelis
 *
 *                  Eggerstedtstr. 28
 *                  22765 Hamburg
 *                  Germany
 *
 *                  Tel:    +49 / 40 / 384298    (private)
 *                  Tel:    +49 / 40 / 55903-170 (at work)
 *                  e-mail: hm@hcshh.hcs.de
 *
 *                          --------oOo--------
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *---------------------------------------------------------------------------*
 *
 *	Last Edit-Date: [Mon Sep 20 16:52:10 1993]
 *
 *	-hm	adding compilation revision numbers
 *	-hm	prototyping, updating, vt220 support
 *	-hm	386bsd intro
 *	-hm	hpterm, hpux 9.0
 *	-hm	interactive configuration
 *	-hm	altcharset in config.c on hpux
 *	-hm	preserve bug fixed in hpux
 *	-hm	multiple extension support in commandline.c
 *	-hm	fkey label structures
 *	-hm	wildcards
 *	-hm	cdrom options
 *	-hm	primitive filename completition
 *	-hm	option display dot-filenames
 *	-hm	option processing
 *	-hm	added patchlevel.h for submission
 *	-hm	released to comp.sources.misc
 *
 *----------------------------------------------------------------------------*/

#include "wish.h"
#include "patchlevel.h"

/*---------------------------------------------------------------------------*
 *	format the headerline
 *---------------------------------------------------------------------------*/
void init_header(void)
{
	sprintf(headerline, "Wish %s.%02d  (c)Copyright 1988-1993 Hellmuth Michaelis, Hamburg [%6.6s]       ", 
	PATCHLEVEL,
#include "update.h"
	,term_string);
}

/*---------------------------------------------------------------------------*
 *	format & print the usage display
 *---------------------------------------------------------------------------*/
void usage(void)
{
	fprintf(stderr,"\n   Wish - WindowShell  Revision %s.%02d, %s, %s\n",
	PATCHLEVEL,
#include "update.h"
	,__DATE__,__TIME__);
	fprintf(stderr,"Copyright (c) 1988 - 1993 by Hellmuth Michaelis, Hamburg, Germany\n\n");
	fprintf(stderr," Wish comes with ABSOLUTELY NO WARRANTY; for details see the file\n");
	fprintf(stderr," COPYING, which should have come with the source for this program.\n");
	fprintf(stderr,"   This is free software, and you are welcome to redistribute it\n");
	fprintf(stderr,"      under certain conditions; see file COPYING for details.\n\n");
	fprintf(stderr,"     Usage:   wish [[+ | -] [acCdflnprw]] | [-?]\n\n");
	fprintf(stderr,"   Options:   +/-a  file attributes display window on/off\n");
	fprintf(stderr,"              +/-c  enable special cdrom filename processing (\";\") on/off\n");
	fprintf(stderr,"              +/-C  on cdrom handle programs as data files on/off\n");
	fprintf(stderr,"              +/-d  preserve current directory when \"cd ..\" on/off\n");
	fprintf(stderr,"              +/-f  display virtual fkey labels window on/off\n");
	fprintf(stderr,"              +/-l  file link detection enable on/off\n");
	fprintf(stderr,"              +/-n  display filenames beginning with a dot (\".\") on/off\n");
	fprintf(stderr,"              +/-p  display the current directory (as a \".\") on/off\n");
	fprintf(stderr,"              +/-r  wait for return after external command on/off\n");
	fprintf(stderr,"              +/-w  enable wildcard filename processing on/off\n");	
	fprintf(stderr,"              -?    display this help text\n\n");
	exit(99);	
}

/*---------------------------------- EOF -------------------------------------*/
