/*---------------------------------------------------------------------------*
 *
 *                  wish - windowing user friendly shell
 *                  ------------------------------------
 *
 *               Copyright (c) 1988-1993 Hellmuth Michaelis
 *
 *                  Eggerstedtstr. 28
 *                  22765 Hamburg
 *                  Germany
 *
 *                  Tel:    +49 / 40 / 384298    (private)
 *                  Tel:    +49 / 40 / 55903-170 (at work)
 *                  e-mail: hm@hcshh.hcs.de
 *
 *                          --------oOo--------
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *---------------------------------------------------------------------------*
 *
 * This is based on some file i got from some Berkley distribution years ago,
 * i really forgot which one, and i forgot the name of the file this is from,
 * so i just copied the copyright notice from some other file:
 *
 * Copyright (c) 1988 The Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that: (1) source distributions retain this entire copyright
 * notice and comment, and (2) distributions including binaries display
 * the following acknowledgement:  ``This product includes software
 * developed by the University of California, Berkeley and its contributors''
 * in the documentation or other materials provided with the distribution
 * and in all advertising materials mentioning features or use of this
 * software. Neither the name of the University nor the names of its
 * contributors may be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 *---------------------------------------------------------------------------*
 *
 *	last edit-date: [Wed Sep 22 13:28:38 1993]
 *
 *	-hm	caching uid/gid entries
 *	-hm	new calling sequence
 *
 *---------------------------------------------------------------------------*/ 

#include "wish.h"

#ifndef min
#define min(x, y)	(((x) < (y)) ? (x) : (y))
#endif

#define	NCACHE		256
#define	MASK		(NCACHE - 1)
#define NAMELENGTH	16

/*---------------------------------------------------------------------------*
 *	make a user id string from the numeric user id (and cache a bit)
 *---------------------------------------------------------------------------*/
char *user_from_uid(uid_t uid, int size)
{
	static struct ncache
	{
		uid_t	uid;
		char	name[NAMELENGTH];
	} c_uid[NCACHE];

	static char nbuf[15];
	register struct passwd *pw;
	register struct ncache *cp;
	int length = min(NAMELENGTH, size);
	
	cp = (c_uid + (uid & MASK));

	if (cp->uid != uid || !*cp->name)
	{
		if (!(pw = getpwuid(uid)))
		{
			sprintf(nbuf, "%-*u", length, uid);
			return(nbuf);
		}
		cp->uid = uid;
		sprintf(cp->name, "%-*s", NAMELENGTH, pw->pw_name);
	}
	strncpy(nbuf, cp->name, length);
	return(nbuf);
}

/*---------------------------------------------------------------------------*
 *	make a group id string from the numeric group id (and cache a bit)
 *---------------------------------------------------------------------------*/
char *group_from_gid(gid_t gid, int size)
{
	static struct ncache
	{
		gid_t	gid;
		char	name[NAMELENGTH];
	} c_gid[NCACHE];

	static char nbuf[15];
	register struct group *gr;
	register struct ncache *cp;
	int length = min(NAMELENGTH, size);
	
	cp = c_gid + (gid & MASK);
	if (cp->gid != gid || !*cp->name)
	{
		if (!(gr = getgrgid(gid)))
		{
			sprintf(nbuf, "%-*u", length, gid);
			return(nbuf);
		}
		cp->gid = gid;
		sprintf(cp->name, "%-*s", NAMELENGTH, gr->gr_name);
	}

	strncpy(nbuf, cp->name, length);
	return(nbuf);
}

/*---------------------------------- EOF -------------------------------------*/
